function [tOut,xOut,tOutRK4,xOutRK4] = fentanylSim(inpTimes)
    %% inpTimes needs to have two columns. time + input
    [nTime,tmp]=size(inpTimes); 
    %% parameters
    k10=0.3955;
    k12=0.3234;
    k13=0.0222;
    k21=0.1468;
    k31=0.0155;
    ke0=0.9242;
    V1=7100;
    V2=15600;
    V3=10200;
    
    A= [ -(k10 + k12 + k12)  k21*V2/V1 k31*V3/V1  0; 
         k12*V1/V2  -k21 0  0;
         k13*V1/V3  0   -k31 0; 
         ke0   0   0  -ke0 
         ];
    
    Ainv = inv(A);
   
    tStep = 0.1;

    
   [tOutRK4,xOutRK4] = ode45(@evalDerivative,[0,inpTimes(nTime,1)+10.0], zeros(4,1) );
   
     
    eMat = expm(tStep*A)
    uMat = 1/V1 * inv(A) * (eMat - eye(4))
    
    xT=zeros(4,1);
    xOut = ones(100,4);
    tOut= ones(100,1);
    for j=1:((inpTimes(nTime,1)+10.0)/tStep)
        t = tStep *j;
        xT = eMat * xT + uMat * getU(t);
        tOut(j,1) = t;
        xOut(j,:)= transpose(xT(:,1));
    end    
    
    function d = evalDerivative(t,x)
        u = getU(t);
        d = A * x + 1/V1 * u ;
    end


    function u = getU(t) 
        u=zeros(4,1);
        for i=1:nTime
            if (t <= inpTimes(i,1))
                u(1,1)=inpTimes(i,2);
                return;
            end
        end
    end
   
   
end
