
module Strmap = Map.Make (
  struct
    type t = string
    let compare = String.compare
  end
)

module Strhash = Hashtbl.Make (
  struct
    type t = string
    let equal a b = (String.compare a b) = 0
    let hash = Hashtbl.hash
  end
)

module Inthash = Hashtbl.Make (
  struct 
    type t = int
    let equal a b = a = b
    let hash = Hashtbl.hash
  end
 )

module Strset = Set.Make (
  struct
    type t = string
    let compare = String.compare
  end
)

module Intset = Set.Make (
  struct
    type t = int
    let compare a b = a-b
  end
)

module IntPairhash = Hashtbl.Make (
  struct
    type t = (int * int)
    let equal (a,b) (c,d) = (a=c) && (b = d)
    let hash = Hashtbl.hash
  end
)
	
exception Success

let chooseRandomValFromRange l u = 
	Random.self_init();
	let f = Random.float 1.0 in 
	   l +. ( u -. l) *. f
		
let chooseRandomValFromList iList = 
	let i = Random.int (List.length iList) in 
	 try List.nth iList i with | Failure _ -> assert false 

	

let convertToFloat str = 
  (* We neet to handle Z3s quirk *)
  try 
    float_of_string str
  with 
    | Failure _ -> 
      (
	if (String.contains str '/')
	then (
	  let ind = String.index str '/' in 
	  let str1 = String.sub str 0 ind in 
	  let str2 = String.sub str (ind+1) ((String.length str) - ind -1) in 
	  try 
	    let f1 = float_of_string str1 in 
	    let f2 = float_of_string str2 in 
	    f1 /. f2 
	  with | Failure _ -> assert false
	) else 
	  assert false
      )
    
