(*--- 
 External Interface to yices 
 --*)

type yices_context

type yices_expr

type assertion_id

type yices_model

external mk_context : unit -> yices_context = "c_ex_yices_mk_context"
external del_context : yices_context -> unit = "c_ex_yices_del_context"
external reset: yices_context -> unit = "c_ex_yices_reset"
external dump_context: yices_context -> unit = "c_ex_yices_dump_context"
external push: yices_context -> unit = "c_ex_yices_push"
external pop: yices_context -> unit = "c_ex_yices_pop"
external assert_expr: yices_context -> yices_expr -> unit = "c_ex_yices_assert"
external assert_expr_retractable: yices_context -> yices_expr -> assertion_id = "c_ex_yices_assert_retractable"
external retract: yices_context -> assertion_id -> unit = "c_ex_yices_retract"
external inconsistent: yices_context -> bool = "c_ex_yices_inconsistent"
external check_ctx: yices_context -> int = "c_ex_yices_check"
external get_model: yices_context -> yices_model = "c_ex_yices_get_model"
external mk_true: yices_context -> yices_expr = "c_ex_yices_mk_true"
external mk_false: yices_context -> yices_expr = "c_ex_yices_mk_false"
external mk_bool_var: yices_context -> string -> yices_expr = "c_ex_yices_mk_bool_var"
external mk_fresh_bool_var: yices_context -> yices_expr = "c_ex_yices_mk_fresh_bool_var"
external mk_or: yices_context -> yices_expr array -> yices_expr = "c_ex_yices_mk_or"
external mk_and: yices_context -> yices_expr array -> yices_expr = "c_ex_yices_mk_and"
external mk_and2: yices_context -> yices_expr -> yices_expr -> yices_expr = "c_ex_yices_mk_and_2"
external mk_or2: yices_context -> yices_expr -> yices_expr -> yices_expr = "c_ex_yices_mk_or_2"
external mk_eq: yices_context -> yices_expr -> yices_expr -> yices_expr = "c_ex_yices_mk_eq"
external mk_diseq: yices_context -> yices_expr -> yices_expr -> yices_expr = "c_ex_yices_mk_diseq"
external mk_ge: yices_context -> yices_expr -> yices_expr -> yices_expr = "c_ex_yices_mk_ge"
external mk_le: yices_context -> yices_expr -> yices_expr -> yices_expr = "c_ex_yices_mk_le"
external mk_gt: yices_context -> yices_expr -> yices_expr -> yices_expr = "c_ex_yices_mk_gt"
external mk_lt: yices_context -> yices_expr -> yices_expr -> yices_expr = "c_ex_yices_mk_lt"
external mk_ite: yices_context -> yices_expr -> yices_expr -> yices_expr -> yices_expr = "c_ex_yices_mk_ite"
external mk_not: yices_context -> yices_expr -> yices_expr = "c_ex_yices_mk_not"
external pp_expr: yices_expr -> unit = "c_ex_yices_pp_expr"
external add: yices_context -> yices_expr -> yices_expr -> yices_expr = "c_ex_yices_add"
external sub: yices_context -> yices_expr -> yices_expr -> yices_expr = "c_ex_yices_sub"
external mul: yices_context -> yices_expr -> yices_expr -> yices_expr = "c_ex_yices_mul"
external mk_num_from_string: yices_context -> string -> yices_expr = "c_ex_yices_mk_num_from_str"
external mk_num: yices_context -> int -> yices_expr = "c_ex_yices_mk_num"
external mk_int_var: yices_context -> string -> yices_expr = "c_ex_yices_mk_int_var"
external mk_real_var: yices_context -> string -> yices_expr = "c_ex_yices_mk_real_var"
external eval_bool_var: yices_model -> yices_expr -> int = "c_ex_yices_eval_bool_var"
external eval_real_var: yices_model -> yices_expr -> float = "c_ex_yices_eval_real_var"
external eval_int_var: yices_model -> yices_expr -> int = "c_ex_yices_eval_int_var"




